; 

    include \masm32\include\masm32rt.inc
    include dbgwin.asm

    IDC_OPEN equ 101
    IDC_SEND equ 102

; 

    ADDS MACRO lpString

      invoke SendMessage, hDebugList, LB_ADDSTRING, 0, lpString

      ; ---------------------------------------------------------
      ; Select the string, and scroll it into view if necessary.
      ; ---------------------------------------------------------

      invoke SendMessage, hDebugList, LB_SETCURSEL, eax, 0

    ENDM
    
; 
    .data
      hInstance dd 0
    .code
; 

DlgProc proc hWndDlg:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

    Switch uMsg

      Case WM_COMMAND

        mov eax, wParam
          
        .IF ax == IDC_OPEN && hDebugDlg == 0

          ; -------------------------------------------------------------
          ; By specifying this window as the parent of the debug window,
          ; the debug window becomes a child window that will always be
          ; above this window in the z-order, and will be minimized or
          ; destroyed when this window is minimized or destroyed.
          ; -------------------------------------------------------------

          invoke CreateDebugWindow, hWndDlg
        

        .ELSEIF ax == IDC_SEND

          .IF hDebugDlg == 0
            invoke CreateDebugWindow, hWndDlg
          .ENDIF

          ADDS chr$("abcdefghijklmnopqrstuvwxyz")

        .ENDIF

      Case WM_CLOSE

        invoke EndDialog, hWndDlg, 0

    Endsw

    xor eax, eax
    ret

DlgProc endp

; 
start:
; 

    invoke GetModuleHandle, NULL
    mov hInstance, eax

    Dialog "Test", \
           "MS Sans Serif", 10, \
           WS_OVERLAPPED or WS_SYSMENU or WS_MINIMIZEBOX, \
           2, 0, 0, 120, 90, 1024

    DlgButton "Open", 0, 18, 50, 35, 12, IDC_OPEN

    DlgButton "Send", 0, 63, 50, 35, 12, IDC_SEND

    CallModalDialog hInstance, 0, DlgProc, NULL

    exit

; 
end start

